diff a/src/hotspot/share/opto/parse2.cpp b/src/hotspot/share/opto/parse2.cpp
--- a/src/hotspot/share/opto/parse2.cpp
+++ b/src/hotspot/share/opto/parse2.cpp
@@ -22,10 +22,11 @@
  *
  */
 
 #include "precompiled.hpp"
 #include "ci/ciMethodData.hpp"
+#include "ci/ciSymbols.hpp"
 #include "classfile/vmSymbols.hpp"
 #include "compiler/compileLog.hpp"
 #include "interpreter/linkResolver.hpp"
 #include "jvm_io.h"
 #include "memory/resourceArea.hpp"
@@ -34,10 +35,12 @@
 #include "opto/addnode.hpp"
 #include "opto/castnode.hpp"
 #include "opto/convertnode.hpp"
 #include "opto/divnode.hpp"
 #include "opto/idealGraphPrinter.hpp"
+#include "opto/idealKit.hpp"
+#include "opto/inlinetypenode.hpp"
 #include "opto/matcher.hpp"
 #include "opto/memnode.hpp"
 #include "opto/mulnode.hpp"
 #include "opto/opaquenode.hpp"
 #include "opto/parse.hpp"
@@ -48,62 +51,278 @@
 #ifndef PRODUCT
 extern uint explicit_null_checks_inserted,
             explicit_null_checks_elided;
 #endif
 
+Node* Parse::record_profile_for_speculation_at_array_load(Node* ld) {
+  // Feed unused profile data to type speculation
+  if (UseTypeSpeculation && UseArrayLoadStoreProfile) {
+    ciKlass* array_type = nullptr;
+    ciKlass* element_type = nullptr;
+    ProfilePtrKind element_ptr = ProfileMaybeNull;
+    bool flat_array = true;
+    bool null_free_array = true;
+    method()->array_access_profiled_type(bci(), array_type, element_type, element_ptr, flat_array, null_free_array);
+    if (element_type != nullptr || element_ptr != ProfileMaybeNull) {
+      ld = record_profile_for_speculation(ld, element_type, element_ptr);
+    }
+  }
+  return ld;
+}
+
+
 //---------------------------------array_load----------------------------------
 void Parse::array_load(BasicType bt) {
   const Type* elemtype = Type::TOP;
-  bool big_val = bt == T_DOUBLE || bt == T_LONG;
   Node* adr = array_addressing(bt, 0, elemtype);
   if (stopped())  return;     // guaranteed null or range check
 
-  pop();                      // index (already used)
-  Node* array = pop();        // the array itself
+  Node* idx = pop();
+  Node* ary = pop();
+
+  // Handle inline type arrays
+  const TypeOopPtr* elemptr = elemtype->make_oopptr();
+  const TypeAryPtr* ary_t = _gvn.type(ary)->is_aryptr();
+  if (ary_t->is_flat()) {
+    // Load from flat inline type array
+    Node* vt = InlineTypeNode::make_from_flat(this, elemtype->inline_klass(), ary, adr);
+    push(vt);
+    return;
+  } else if (ary_t->is_null_free()) {
+    // Load from non-flat inline type array (elements can never be null)
+    bt = T_OBJECT;
+  } else if (!ary_t->is_not_flat()) {
+    // Cannot statically determine if array is a flat array, emit runtime check
+    assert(UseFlatArray && is_reference_type(bt) && elemptr->can_be_inline_type() && !ary_t->klass_is_exact() && !ary_t->is_not_null_free() &&
+           (!elemptr->is_inlinetypeptr() || elemptr->inline_klass()->flat_in_array()), "array can't be flat");
+    IdealKit ideal(this);
+    IdealVariable res(ideal);
+    ideal.declarations_done();
+    ideal.if_then(flat_array_test(ary, /* flat = */ false)); {
+      // non-flat array
+      assert(ideal.ctrl()->in(0)->as_If()->is_flat_array_check(&_gvn), "Should be found");
+      sync_kit(ideal);
+      const TypeAryPtr* adr_type = TypeAryPtr::get_array_body_type(bt);
+      Node* ld = access_load_at(ary, adr, adr_type, elemptr, bt,
+                                IN_HEAP | IS_ARRAY | C2_CONTROL_DEPENDENT_LOAD);
+      if (elemptr->is_inlinetypeptr()) {
+        assert(elemptr->maybe_null(), "null free array should be handled above");
+        ld = InlineTypeNode::make_from_oop(this, ld, elemptr->inline_klass(), false);
+      }
+      ideal.sync_kit(this);
+      ideal.set(res, ld);
+    } ideal.else_(); {
+      // flat array
+      sync_kit(ideal);
+      if (elemptr->is_inlinetypeptr()) {
+        // Element type is known, cast and load from flat representation
+        ciInlineKlass* vk = elemptr->inline_klass();
+        assert(vk->flat_in_array() && elemptr->maybe_null(), "never/always flat - should be optimized");
+        ciArrayKlass* array_klass = ciArrayKlass::make(vk, /* null_free */ true);
+        const TypeAryPtr* arytype = TypeOopPtr::make_from_klass(array_klass)->isa_aryptr();
+        Node* cast = _gvn.transform(new CheckCastPPNode(control(), ary, arytype));
+        Node* casted_adr = array_element_address(cast, idx, T_OBJECT, ary_t->size(), control());
+        // Re-execute flat array load if buffering triggers deoptimization
+        PreserveReexecuteState preexecs(this);
+        jvms()->set_should_reexecute(true);
+        inc_sp(2);
+        Node* vt = InlineTypeNode::make_from_flat(this, vk, cast, casted_adr)->buffer(this, false);
+        ideal.set(res, vt);
+        ideal.sync_kit(this);
+      } else {
+        // Element type is unknown, emit runtime call
+
+        // Below membars keep this access to an unknown flat array correctly
+        // ordered with other unknown and known flat array accesses.
+        insert_mem_bar_volatile(Op_MemBarCPUOrder, C->get_alias_index(TypeAryPtr::INLINES));
+
+        Node* call = nullptr;
+        {
+          // Re-execute flat array load if runtime call triggers deoptimization
+          PreserveReexecuteState preexecs(this);
+          jvms()->set_bci(_bci);
+          jvms()->set_should_reexecute(true);
+          inc_sp(2);
+          kill_dead_locals();
+          call = make_runtime_call(RC_NO_LEAF | RC_NO_IO,
+                                   OptoRuntime::load_unknown_inline_type(),
+                                   OptoRuntime::load_unknown_inline_Java(),
+                                   nullptr, TypeRawPtr::BOTTOM,
+                                   ary, idx);
+        }
+        make_slow_call_ex(call, env()->Throwable_klass(), false);
+        Node* buffer = _gvn.transform(new ProjNode(call, TypeFunc::Parms));
+
+        insert_mem_bar_volatile(Op_MemBarCPUOrder, C->get_alias_index(TypeAryPtr::INLINES));
+
+        // Keep track of the information that the inline type is in flat arrays
+        const Type* unknown_value = elemptr->is_instptr()->cast_to_flat_in_array();
+        buffer = _gvn.transform(new CheckCastPPNode(control(), buffer, unknown_value));
+
+        ideal.sync_kit(this);
+        ideal.set(res, buffer);
+      }
+    } ideal.end_if();
+    sync_kit(ideal);
+    Node* ld = _gvn.transform(ideal.value(res));
+    ld = record_profile_for_speculation_at_array_load(ld);
+    push_node(bt, ld);
+    return;
+  }
 
   if (elemtype == TypeInt::BOOL) {
     bt = T_BOOLEAN;
   }
   const TypeAryPtr* adr_type = TypeAryPtr::get_array_body_type(bt);
-
-  Node* ld = access_load_at(array, adr, adr_type, elemtype, bt,
+  Node* ld = access_load_at(ary, adr, adr_type, elemtype, bt,
                             IN_HEAP | IS_ARRAY | C2_CONTROL_DEPENDENT_LOAD);
-  if (big_val) {
-    push_pair(ld);
-  } else {
-    push(ld);
+  ld = record_profile_for_speculation_at_array_load(ld);
+  // Loading an inline type from a non-flat array
+  if (elemptr != nullptr && elemptr->is_inlinetypeptr()) {
+    assert(!ary_t->is_null_free() || !elemptr->maybe_null(), "inline type array elements should never be null");
+    ld = InlineTypeNode::make_from_oop(this, ld, elemptr->inline_klass(), !elemptr->maybe_null());
   }
+  push_node(bt, ld);
 }
 
 
 //--------------------------------array_store----------------------------------
 void Parse::array_store(BasicType bt) {
   const Type* elemtype = Type::TOP;
-  bool big_val = bt == T_DOUBLE || bt == T_LONG;
-  Node* adr = array_addressing(bt, big_val ? 2 : 1, elemtype);
+  Node* adr = array_addressing(bt, type2size[bt], elemtype);
   if (stopped())  return;     // guaranteed null or range check
+  Node* cast_val = nullptr;
   if (bt == T_OBJECT) {
-    array_store_check();
-    if (stopped()) {
-      return;
-    }
-  }
-  Node* val;                  // Oop to store
-  if (big_val) {
-    val = pop_pair();
-  } else {
-    val = pop();
+    cast_val = array_store_check(adr, elemtype);
+    if (stopped()) return;
   }
-  pop();                      // index (already used)
-  Node* array = pop();        // the array itself
+  Node* val = pop_node(bt); // Value to store
+  Node* idx = pop();        // Index in the array
+  Node* ary = pop();        // The array itself
+
+  const TypeAryPtr* ary_t = _gvn.type(ary)->is_aryptr();
+  const TypeAryPtr* adr_type = TypeAryPtr::get_array_body_type(bt);
 
   if (elemtype == TypeInt::BOOL) {
     bt = T_BOOLEAN;
+  } else if (bt == T_OBJECT) {
+    elemtype = elemtype->make_oopptr();
+    const Type* tval = _gvn.type(cast_val);
+    // Based on the value to be stored, try to determine if the array is not null-free and/or not flat.
+    // This is only legal for non-null stores because the array_store_check always passes for null, even
+    // if the array is null-free. Null stores are handled in GraphKit::gen_inline_array_null_guard().
+    bool not_null_free = !tval->maybe_null() && !tval->is_oopptr()->can_be_inline_type();
+    bool not_flat = not_null_free || (tval->is_inlinetypeptr() && !tval->inline_klass()->flat_in_array());
+    if (!ary_t->is_not_null_free() && not_null_free) {
+      // Storing a non-inline type, mark array as not null-free (-> not flat).
+      ary_t = ary_t->cast_to_not_null_free();
+      Node* cast = _gvn.transform(new CheckCastPPNode(control(), ary, ary_t));
+      replace_in_map(ary, cast);
+      ary = cast;
+    } else if (!ary_t->is_not_flat() && not_flat) {
+      // Storing to a non-flat array, mark array as not flat.
+      ary_t = ary_t->cast_to_not_flat();
+      Node* cast = _gvn.transform(new CheckCastPPNode(control(), ary, ary_t));
+      replace_in_map(ary, cast);
+      ary = cast;
+    }
+
+    if (ary_t->is_flat()) {
+      // Store to flat inline type array
+      assert(!tval->maybe_null(), "should be guaranteed by array store check");
+      // Re-execute flat array store if buffering triggers deoptimization
+      PreserveReexecuteState preexecs(this);
+      inc_sp(3);
+      jvms()->set_should_reexecute(true);
+      cast_val->as_InlineType()->store_flat(this, ary, adr, nullptr, 0, MO_UNORDERED | IN_HEAP | IS_ARRAY);
+      return;
+    } else if (ary_t->is_null_free()) {
+      // Store to non-flat inline type array (elements can never be null)
+      assert(!tval->maybe_null(), "should be guaranteed by array store check");
+      if (elemtype->inline_klass()->is_empty()) {
+        // Ignore empty inline stores, array is already initialized.
+        return;
+      }
+    } else if (!ary_t->is_not_flat() && (tval != TypePtr::NULL_PTR || StressReflectiveCode)) {
+      // Array might be a flat array, emit runtime checks (for nullptr, a simple inline_array_null_guard is sufficient).
+      assert(UseFlatArray && !not_flat && elemtype->is_oopptr()->can_be_inline_type() &&
+             !ary_t->klass_is_exact() && !ary_t->is_not_null_free(), "array can't be a flat array");
+      IdealKit ideal(this);
+      ideal.if_then(flat_array_test(ary, /* flat = */ false)); {
+        // non-flat array
+        assert(ideal.ctrl()->in(0)->as_If()->is_flat_array_check(&_gvn), "Should be found");
+        sync_kit(ideal);
+        Node* cast_ary = inline_array_null_guard(ary, cast_val, 3);
+        inc_sp(3);
+        access_store_at(cast_ary, adr, adr_type, cast_val, elemtype, bt, MO_UNORDERED | IN_HEAP | IS_ARRAY, false);
+        dec_sp(3);
+        ideal.sync_kit(this);
+      } ideal.else_(); {
+        sync_kit(ideal);
+        // flat array
+        Node* null_ctl = top();
+        Node* val = null_check_oop(cast_val, &null_ctl);
+        if (null_ctl != top()) {
+          PreserveJVMState pjvms(this);
+          inc_sp(3);
+          set_control(null_ctl);
+          uncommon_trap(Deoptimization::Reason_null_check, Deoptimization::Action_none);
+          dec_sp(3);
+        }
+        // Try to determine the inline klass
+        ciInlineKlass* vk = nullptr;
+        if (tval->is_inlinetypeptr()) {
+          vk = tval->inline_klass();
+        } else if (elemtype->is_inlinetypeptr()) {
+          vk = elemtype->inline_klass();
+        }
+        Node* casted_ary = ary;
+        if (vk != nullptr && !stopped()) {
+          // Element type is known, cast and store to flat representation
+          assert(vk->flat_in_array() && elemtype->maybe_null(), "never/always flat - should be optimized");
+          ciArrayKlass* array_klass = ciArrayKlass::make(vk, /* null_free */ true);
+          const TypeAryPtr* arytype = TypeOopPtr::make_from_klass(array_klass)->isa_aryptr();
+          casted_ary = _gvn.transform(new CheckCastPPNode(control(), casted_ary, arytype));
+          Node* casted_adr = array_element_address(casted_ary, idx, T_OBJECT, arytype->size(), control());
+          if (!val->is_InlineType()) {
+            assert(!gvn().type(val)->maybe_null(), "inline type array elements should never be null");
+            val = InlineTypeNode::make_from_oop(this, val, vk);
+          }
+          // Re-execute flat array store if buffering triggers deoptimization
+          PreserveReexecuteState preexecs(this);
+          inc_sp(3);
+          jvms()->set_should_reexecute(true);
+          val->as_InlineType()->store_flat(this, casted_ary, casted_adr, nullptr, 0, MO_UNORDERED | IN_HEAP | IS_ARRAY);
+        } else if (!stopped()) {
+          // Element type is unknown, emit runtime call
+
+          // Below membars keep this access to an unknown flat array correctly
+          // ordered with other unknown and known flat array accesses.
+          insert_mem_bar_volatile(Op_MemBarCPUOrder, C->get_alias_index(TypeAryPtr::INLINES));
+
+          make_runtime_call(RC_LEAF,
+                            OptoRuntime::store_unknown_inline_type(),
+                            CAST_FROM_FN_PTR(address, OptoRuntime::store_unknown_inline),
+                            "store_unknown_inline", TypeRawPtr::BOTTOM,
+                            val, casted_ary, idx);
+
+          insert_mem_bar_volatile(Op_MemBarCPUOrder, C->get_alias_index(TypeAryPtr::INLINES));
+        }
+        ideal.sync_kit(this);
+      }
+      ideal.end_if();
+      sync_kit(ideal);
+      return;
+    } else if (!ary_t->is_not_null_free()) {
+      // Array is not flat but may be null free
+      assert(elemtype->is_oopptr()->can_be_inline_type() && !ary_t->klass_is_exact(), "array can't be null-free");
+      ary = inline_array_null_guard(ary, cast_val, 3, true);
+    }
   }
-  const TypeAryPtr* adr_type = TypeAryPtr::get_array_body_type(bt);
-
-  access_store_at(array, adr, adr_type, val, elemtype, bt, MO_UNORDERED | IN_HEAP | IS_ARRAY);
+  inc_sp(3);
+  access_store_at(ary, adr, adr_type, val, elemtype, bt, MO_UNORDERED | IN_HEAP | IS_ARRAY);
+  dec_sp(3);
 }
 
 
 //------------------------------array_addressing-------------------------------
 // Pull array and index from the stack.  Compute pointer-to-element.
@@ -200,10 +419,126 @@
     }
   }
   // Check for always knowing you are throwing a range-check exception
   if (stopped())  return top();
 
+  // This could be an access to an inline type array. We can't tell if it's
+  // flat or not. Knowing the exact type avoids runtime checks and leads to
+  // a much simpler graph shape. Check profile information.
+  if (!arytype->is_flat() && !arytype->is_not_flat()) {
+    // First check the speculative type
+    Deoptimization::DeoptReason reason = Deoptimization::Reason_speculate_class_check;
+    ciKlass* array_type = arytype->speculative_type();
+    if (too_many_traps_or_recompiles(reason) || array_type == nullptr) {
+      // No speculative type, check profile data at this bci
+      array_type = nullptr;
+      reason = Deoptimization::Reason_class_check;
+      if (UseArrayLoadStoreProfile && !too_many_traps_or_recompiles(reason)) {
+        ciKlass* element_type = nullptr;
+        ProfilePtrKind element_ptr = ProfileMaybeNull;
+        bool flat_array = true;
+        bool null_free_array = true;
+        method()->array_access_profiled_type(bci(), array_type, element_type, element_ptr, flat_array, null_free_array);
+      }
+    }
+    if (array_type != nullptr) {
+      // Speculate that this array has the exact type reported by profile data
+      Node* better_ary = nullptr;
+      DEBUG_ONLY(Node* old_control = control();)
+      Node* slow_ctl = type_check_receiver(ary, array_type, 1.0, &better_ary);
+      if (stopped()) {
+        // The check always fails and therefore profile information is incorrect. Don't use it.
+        assert(old_control == slow_ctl, "type check should have been removed");
+        set_control(slow_ctl);
+      } else if (!slow_ctl->is_top()) {
+        { PreserveJVMState pjvms(this);
+          set_control(slow_ctl);
+          uncommon_trap_exact(reason, Deoptimization::Action_maybe_recompile);
+        }
+        replace_in_map(ary, better_ary);
+        ary = better_ary;
+        arytype  = _gvn.type(ary)->is_aryptr();
+        elemtype = arytype->elem();
+      }
+    }
+  } else if (UseTypeSpeculation && UseArrayLoadStoreProfile) {
+    // No need to speculate: feed profile data at this bci for the
+    // array to type speculation
+    ciKlass* array_type = nullptr;
+    ciKlass* element_type = nullptr;
+    ProfilePtrKind element_ptr = ProfileMaybeNull;
+    bool flat_array = true;
+    bool null_free_array = true;
+    method()->array_access_profiled_type(bci(), array_type, element_type, element_ptr, flat_array, null_free_array);
+    if (array_type != nullptr) {
+      ary = record_profile_for_speculation(ary, array_type, ProfileMaybeNull);
+    }
+  }
+
+  // We have no exact array type from profile data. Check profile data
+  // for a non null-free or non flat array. Non null-free implies non
+  // flat so check this one first. Speculating on a non null-free
+  // array doesn't help aaload but could be profitable for a
+  // subsequent aastore.
+  if (!arytype->is_null_free() && !arytype->is_not_null_free()) {
+    bool null_free_array = true;
+    Deoptimization::DeoptReason reason = Deoptimization::Reason_none;
+    if (arytype->speculative() != nullptr &&
+        arytype->speculative()->is_aryptr()->is_not_null_free() &&
+        !too_many_traps_or_recompiles(Deoptimization::Reason_speculate_class_check)) {
+      null_free_array = false;
+      reason = Deoptimization::Reason_speculate_class_check;
+    } else if (UseArrayLoadStoreProfile && !too_many_traps_or_recompiles(Deoptimization::Reason_class_check)) {
+      ciKlass* array_type = nullptr;
+      ciKlass* element_type = nullptr;
+      ProfilePtrKind element_ptr = ProfileMaybeNull;
+      bool flat_array = true;
+      method()->array_access_profiled_type(bci(), array_type, element_type, element_ptr, flat_array, null_free_array);
+      reason = Deoptimization::Reason_class_check;
+    }
+    if (!null_free_array) {
+      { // Deoptimize if null-free array
+        BuildCutout unless(this, null_free_array_test(load_object_klass(ary), /* null_free = */ false), PROB_MAX);
+        uncommon_trap_exact(reason, Deoptimization::Action_maybe_recompile);
+      }
+      assert(!stopped(), "null-free array should have been caught earlier");
+      Node* better_ary = _gvn.transform(new CheckCastPPNode(control(), ary, arytype->cast_to_not_null_free()));
+      replace_in_map(ary, better_ary);
+      ary = better_ary;
+      arytype = _gvn.type(ary)->is_aryptr();
+    }
+  }
+
+  if (!arytype->is_flat() && !arytype->is_not_flat()) {
+    bool flat_array = true;
+    Deoptimization::DeoptReason reason = Deoptimization::Reason_none;
+    if (arytype->speculative() != nullptr &&
+        arytype->speculative()->is_aryptr()->is_not_flat() &&
+        !too_many_traps_or_recompiles(Deoptimization::Reason_speculate_class_check)) {
+      flat_array = false;
+      reason = Deoptimization::Reason_speculate_class_check;
+    } else if (UseArrayLoadStoreProfile && !too_many_traps_or_recompiles(reason)) {
+      ciKlass* array_type = nullptr;
+      ciKlass* element_type = nullptr;
+      ProfilePtrKind element_ptr = ProfileMaybeNull;
+      bool null_free_array = true;
+      method()->array_access_profiled_type(bci(), array_type, element_type, element_ptr, flat_array, null_free_array);
+      reason = Deoptimization::Reason_class_check;
+    }
+    if (!flat_array) {
+      { // Deoptimize if flat array
+        BuildCutout unless(this, flat_array_test(ary, /* flat = */ false), PROB_MAX);
+        uncommon_trap_exact(reason, Deoptimization::Action_maybe_recompile);
+      }
+      assert(!stopped(), "flat array should have been caught earlier");
+      Node* better_ary = _gvn.transform(new CheckCastPPNode(control(), ary, arytype->cast_to_not_flat()));
+      replace_in_map(ary, better_ary);
+      ary = better_ary;
+      arytype = _gvn.type(ary)->is_aryptr();
+    }
+  }
+
   // Make array address computation control dependent to prevent it
   // from floating above the range check during loop optimizations.
   Node* ptr = array_element_address(ary, idx, type, sizetype, control());
   assert(ptr != top(), "top should go hand-in-hand with stopped");
 
@@ -1455,11 +1790,11 @@
     adjust_map_after_if(BoolTest(btest).negate(), c, 1.0-prob, next_block);
   }
 }
 
 //------------------------------------do_if------------------------------------
-void Parse::do_if(BoolTest::mask btest, Node* c) {
+void Parse::do_if(BoolTest::mask btest, Node* c, bool can_trap, bool new_path, Node** ctrl_taken) {
   int target_bci = iter().get_dest();
 
   Block* branch_block = successor_for_bci(target_bci);
   Block* next_block   = successor_for_bci(iter().next_bci());
 
